#!/usr/pkg/bin/perl

use Getopt::Long;

my $command;
my $output_ascii;
my $debug;

GetOptions("command=s" => \$command,
	   "data=s" => \$data,
	   "ascii" => \$output_ascii,
	   "debug" => \$debug) or die("Error in command line arguments\n");

if (defined $command) {
    my $prefix = "a0a1";
    my $suffix = "0d0a";
    $payload_length;
    my $output;
    my %binary;
    my $v;
    my @v;
    my $n;

    die("Misformatted command $command\n") if (length($command) != 1 && length($command) != 2);

    if (length($command) == 1) {
	$command = sprintf("%02X",hex($command));
    }

    if (defined $data) {
	die("Misformatted data $data\n") if ((length($data) % 2) != 0);
    }

    $binary{'prefix'} = pack "H*", $prefix;
    $binary{'suffix'} = pack "H*", $suffix;
    $binary{'command'} = pack "H*", $command;
    $binary{'data'} = pack "H*", $data;
    $payload_length = sprintf("%04X",length($binary{'command'}) + length($binary{'data'}));
    $binary{'payload_length'} = pack "H*", $payload_length;

    $v = 0;
    @v = ($binary{'command'},split('',$binary{'data'}));
    foreach (@v) {
	my $h = unpack "H*", $_;
	my $d = hex($h);
	$v = $v ^ $d;
    }
    $binary{'cs'} = pack "H*", sprintf("%02X",$v);

    foreach ('prefix','payload_length','command','data','cs','suffix') {
	$output .= $binary{$_};
    }
    if (defined $output_ascii) {
	print unpack "H*", $output;
	print "\n";
    } else {
	print $output;
    }
} else {
    print "Missing command line arguments\n";
    exit 1;
}
